VERSION 5.00
Begin VB.Form Ultimate 
   BackColor       =   &H00C0C0C0&
   ClientHeight    =   7800
   ClientLeft      =   60
   ClientTop       =   630
   ClientWidth     =   13800
   BeginProperty Font 
      Name            =   "Times New Roman"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   Icon            =   "Ultimate.frx":0000
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   ScaleHeight     =   520
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   920
   StartUpPosition =   2  'CenterScreen
   Begin VB.PictureBox field 
      AutoSize        =   -1  'True
      FillColor       =   &H00FFFFFF&
      BeginProperty Font 
         Name            =   "Times New Roman"
         Size            =   5.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   7560
      Left            =   120
      Picture         =   "Ultimate.frx":030A
      ScaleHeight     =   500
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   900
      TabIndex        =   0
      Top             =   120
      Width           =   13560
      Begin VB.Timer stallTimer 
         Left            =   960
         Top             =   480
      End
      Begin VB.Timer gameTimer 
         Interval        =   2000
         Left            =   2400
         Top             =   480
      End
      Begin VB.Timer playerTimer 
         Interval        =   500
         Left            =   1920
         Top             =   480
      End
      Begin VB.Timer discTimer 
         Left            =   1440
         Top             =   480
      End
      Begin VB.Label Announcer 
         AutoSize        =   -1  'True
         BackColor       =   &H00FFFFFF&
         BackStyle       =   0  'Transparent
         BeginProperty Font 
            Name            =   "Tahoma"
            Size            =   12
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   285
         Left            =   5400
         TabIndex        =   2
         Top             =   240
         Visible         =   0   'False
         Width           =   75
      End
      Begin VB.Image disc 
         Height          =   105
         Left            =   5040
         Top             =   3720
         Width           =   225
      End
      Begin VB.Label jerseyNum 
         AutoSize        =   -1  'True
         BackStyle       =   0  'Transparent
         Caption         =   "99"
         BeginProperty Font 
            Name            =   "Franklin Gothic Heavy"
            Size            =   8.25
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         ForeColor       =   &H8000000D&
         Height          =   225
         Index           =   0
         Left            =   6840
         TabIndex        =   1
         Top             =   4080
         Width           =   180
      End
      Begin VB.Image player 
         Appearance      =   0  'Flat
         Height          =   495
         Index           =   0
         Left            =   3360
         Top             =   3600
         Width           =   495
      End
   End
   Begin VB.Menu game 
      Caption         =   "&Game"
      Begin VB.Menu gameNew 
         Caption         =   "&New"
         Shortcut        =   ^N
      End
      Begin VB.Menu attributes 
         Caption         =   "Player &Attributes"
         Index           =   0
         Shortcut        =   ^C
      End
      Begin VB.Menu zzbreak 
         Caption         =   "-"
      End
      Begin VB.Menu gameAbout 
         Caption         =   "&About"
      End
      Begin VB.Menu zzzbreak 
         Caption         =   "-"
      End
      Begin VB.Menu gameExit 
         Caption         =   "E&xit"
      End
   End
End
Attribute VB_Name = "Ultimate"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Const RT = 0 'a constant that indicates a team is facing the east side of the field
Const LT = 1 'a constant that indicates a team is facing the west side of the field
Const teams = 1 'actually 2
Const playersOnTeam = 7 'players per team
Const totPlayers = 6 'players per team roster (read as 7)
Const players = 13 'on the field at once (read as 14)
Dim tPU As Integer 'player toPickUp
Dim announceTimer As Integer
Dim chosen(0 To players) As Boolean
Dim rand(0 To players) As Integer
Dim stall As Integer
Dim gameTime
Dim score(0 To 1)
Dim fWidth As Integer  'field width
Dim fHeight As Integer 'field height
Dim duringPull As Boolean 'true if it is during a pull, false otherwise
Dim discPos(0 To 1) 'position of the disc
Dim discMoving As Boolean
Dim discStart(0 To 1)
Dim discTarget(0 To 1) 'the disc's target when it is thrown
Dim outOfBounds '0 if inbounds, 1 if left, 2 top, 3 right, 4 bottom
Dim inPlay '0 or 1 depending on whether or not the disc is currently in play...
'in this simple version of ultimate, if the disc is not in play,
'we must be in between points, or neither team currently has possession of the disc
Dim goalScored 'True if inbetween points (a team just scored), False if during a point
'Dim pullWait 'variable used for causing thrower to pause before pulling
'facing(0) is the direction cornell is facing, facing(1) is the direction harvard is facing
Dim facing(0 To teams) ' = Left or Right, indicates direction a team is pointed on offense
Dim teamOnO 'indicates which team, 0 or 1, is currently on offense
Dim teamName(0 To 1)
Dim playerX(0 To players) 'player's x position on field
Dim playerY(0 To players) 'player's y position on field
Dim inPos(0 To players) 'whether or not a player is inPos
Dim playerGoals(0 To teams, 0 To totPlayers)
Dim playerWithDisc 'player who currently has possession of disc
Dim whoThrewDisc 'player that last released the disc, -1 if none
Dim jer(0 To teams, 0 To totPlayers) As Integer
Dim spe(0 To teams, 0 To totPlayers) As Integer
Dim dis(0 To teams, 0 To totPlayers) As Integer
Dim acc(0 To teams, 0 To totPlayers) As Integer
Dim rea(0 To teams, 0 To totPlayers) As Integer
Dim han(0 To teams, 0 To totPlayers) As Integer
Dim nam(0 To teams, 0 To totPlayers) As String
Dim pos(0 To teams, 0 To totPlayers) As String
Private Sub attributes_Click(Index As Integer)
    Load Settings
    Settings.Show
End Sub
Private Sub player_Click(Index As Integer)
    Load Settings
    Settings.Show
    Settings.comboJer.Text = Str(Index)
    Settings.Load_Click
End Sub
'the getter functions:  (used by settings form)
Function getJer(pl)
    getJer = jer(teamOf(pl), pl Mod playersOnTeam)
End Function
Function getNam(pl)
    getNam = nam(teamOf(pl), pl Mod playersOnTeam)
End Function
Function getSpe(pl)
    getSpe = spe(teamOf(pl), pl Mod playersOnTeam)
End Function
Function getDis(pl)
    getDis = dis(teamOf(pl), pl Mod playersOnTeam)
End Function
Function getAcc(pl) 'also used by bestPass
    getAcc = acc(teamOf(pl), pl Mod playersOnTeam)
End Function
Function getRea(pl)
    getRea = rea(teamOf(pl), pl Mod playersOnTeam)
End Function
Function getHan(pl) 'also used by bestPass
    getHan = han(teamOf(pl), pl Mod playersOnTeam)
End Function
Sub setNam(pl, name)
    nam(teamOf(pl), pl Mod playersOnTeam) = name
End Sub
Sub setSpe(pl, speed)
    spe(teamOf(pl), pl Mod playersOnTeam) = speed
End Sub
Sub setDis(pl, distance)
    dis(teamOf(pl), pl Mod playersOnTeam) = distance
End Sub
Sub setAcc(pl, accuracy)
    acc(teamOf(pl), pl Mod playersOnTeam) = accuracy
End Sub
Sub setRea(pl, reaction)
    rea(teamOf(pl), pl Mod playersOnTeam) = reaction
End Sub
Sub setHan(pl, hands)
    han(teamOf(pl), pl Mod playersOnTeam) = hands
End Sub
Private Sub Form_Load() 'CC
    init
End Sub

Sub init() 'CC
    Randomize Timer
    initVars
    loadData
    loadPlayers (True) 'yes, it's the first time we're loading the players
    loadDisc
    loadStartPos

End Sub
Sub initVars() 'CC
    fWidth = 360
    fHeight = 115
    gameTime = 0
    score(0) = 0
    score(1) = 0
    teamOnO = Int(Rnd * 2)  'determined by a flip
    facing(0) = RT
    facing(1) = LT
    outOfBounds = 0
    whoThrewDisc = -1
    inPlay = 0
    duringPull = False
    goalScored = True 'disc starts in between points, even if a goal wasn't really scored yet

End Sub
'called by gameTimer and by game menu
Sub newGame()
    discTimer.Enabled = False
    initVars
    inPlay = 0
    duringPull = False
    goalScored = True 'even though it's not, just pretend
    loadPlayers (False)
    loadStartPos
    gameTimer.Enabled = True
    playerTimer.Interval = 500
End Sub
'called between each point when teams switch sides
Sub Reset()
    discTimer.Interval = 0
    swapSides
    inPlay = 0
    duringPull = False
    goalScored = True
    loadPlayers (False) 'not the first time we're loading players
    loadStartPos

End Sub
Sub swapSides()
    temp = facing(0)
    facing(0) = facing(1)
    facing(1) = temp
End Sub
'line players up across front of respective endzones
'place disc in the hand of the person who is pulling from teamOnO
Sub loadStartPos() 'CC
    
    For x = 0 To players
        tox = teamOf(x)
        'if player is on right facting team
        
        If facing(tox) = RT Then
            setPlayerPos x, 60, startPosY(x), False
        Else
            setPlayerPos x, 280, startPosY(x), False
        End If
    Next x
    
    playerWithDisc = teamOnO * playersOnTeam
    
    setDiscPos plDiscX(playerWithDisc), plDiscY(playerWithDisc)

End Sub
Sub loadData() 'CC
    Static i As Integer
    teamName(0) = "Cornell":
    teamName(1) = "Harvard":
    'open file for input
    Open "players.txt" For Input As #1
    For x = 0 To teams
        For y = 0 To totPlayers
            Input #1, jer(x, y)
            Input #1, spe(x, y)
            Input #1, dis(x, y)
            Input #1, acc(x, y)
            Input #1, rea(x, y)
            Input #1, han(x, y)
            Line Input #1, nam(x, y)
            pos(x, y) = Left$(nam(x, y), 1)
            nam(x, y) = Right$(nam(x, y), Len(nam(x, y)) - 1)
        Next y
    Next x
    Close #1
End Sub
Sub loadPlayers(firstTime) 'CC
    For x = 0 To players 'x from 0 to 13
        'If t = -1 And
        If (x <> 0) And (firstTime = True) Then Load player(x): Load jerseyNum(x)
        picN = picName(x)
        player(x).Picture = LoadPicture(picN)
        player(x).Visible = True
        jerseyNum(x).Visible = True
    Next x
End Sub
Sub loadDisc() 'CC
    discPic = "disc9.gif"
    disc.Picture = LoadPicture(discPic)
End Sub
Function picName(x) As String 'CC - Modified from Ryazansky's Shepherd Soccer
    tox = teamOf(x)
    face$ = "a"
    If facing(tox) = LT Then face$ = "b"
    picName = "pl" + teamAbb(tox) + face$ + ".gif"
End Function
Function teamAbb(t) 'CC - Modified from Ryazansky's Shepherd Soccer
    teamAbb = Left$(teamName(t), 3)
End Function
'returns team number (0 or 1) that the player is on
Public Function teamOf(p) 'CC
    If p < playersOnTeam Then
        teamOf = 0
    Else
        teamOf = 1
    End If
End Function
'returns team number (0 or 1) that the player is *not* on
Function otherTeam(p) 'CC
    If p < playersOnTeam Then
        otherTeam = 1
    Else
        otherTeam = 0
    End If
End Function

Sub setPlayerPos(p, x, y, checkForDisc) 'CC
    If x = -1 Or y = -1 Then
        player(p).Left = playerX(p) * 2.5
        player(p).Top = playerY(p) * 2.5
    Else
        playerX(p) = x
        playerY(p) = y
        player(p).Left = x * 2.5
        player(p).Top = y * 2.5
    End If
    player(p).ZOrder
    printJersey p
    If (checkForDisc = True) And (playerWithDisc = -1) Then canGetDisc (p)
End Sub

'this function can only be called if the disc is in the air,
'not if it is in someone's possession.
Function canGetDisc(pl)
    'either just check the given player, or check through all players
    sta = pl: fin = pl
    If pl = -1 Then
        'generate a random seq of the players
        'first make all players eligible to be chosen for next spot in sequence
        For r = 0 To players
            chosen(r) = False
        Next r
        For r = 0 To players
            'then find a random player that hasn't already been chosen
            i = Int(Rnd * (players + 1))
            Do While (chosen(i) = True)
                i = Int(Rnd * (players + 1))
            Loop
            rand(r) = i
            chosen(i) = True
        Next r
        sta = 0: fin = players
    End If
    
    For temp = sta To fin
      
      If pl = -1 Then
        p = rand(temp)
      Else
        p = temp
      End If
      
      If (p <> whoThrewDisc Or p = tPU) And playerWithDisc = -1 Then
        
        midOfDiscY = disc.Top + disc.Height / 2
        midOfDiscX = disc.Left + disc.Width / 2
        plNum = p Mod playersOnTeam
        plReachFactor = (han(teamOf(p), plNum) + rea(teamOf(p), plNum)) / 40
        'the maximum reach of any player will be 15, since that is the length of a player,
        'and when players layout, they gain a full body length.
        maxReach = 15
        plReach = Int(plReachFactor * maxReach)
        armTop = player(p).Top - plReach
        armBottom = player(p).Top + player(p).Height + plReach
        armLeft = player(p).Left - plReach
        armRight = player(p).Left + player(p).Width + plReach
        
        canReach = (midOfDiscX >= armLeft And midOfDiscX <= armRight And midOfDiscY >= armTop And midOfDiscY <= armBottom)
        
        If canReach Then
            'if we are on the teamOnO or we should catch the disc for some reason
            If teamOf(p) = teamOnO Or shouldCatch(p) Then
                playerWithDisc = p
                setPlayerWithDisc p
                scored = checkIfScore(p)
                If scored Then Reset 'for new point
            Else 'if we are a non-handler on D, we try to D the disc
                canD = getReact(p) + Int(Rnd * 5) - getAcc(whoThrewDisc)
                If canD >= Int(Rnd * 5) Then
                    'turnover!!
                    Announcer.Caption = "Turnover!  " + teamName(other(teamOnO)) + " disc"
                    Announcer.Visible = True
                    announceTimer = 3
                    playerWithDisc = -1 'still
                    inPlay = 0
                    discTimer.Interval = 0
                    discMoving = False
                    teamOnO = other(teamOnO)
                    'simulate the disc being knocked down by p
                    setDiscPos plDiscX(p), plDiscY(p)
                End If
            End If
        End If
      End If
    Next temp
    'return whether or not the disc was caught by (a) player
    canGetDisc = canReach
    
End Function
'returns true if are a handler or if we are on D in the enzone we want to score in
Function shouldCatch(p)
    shouldCatch = False
    posOfP = p Mod playersOnTeam
    If posOfP = 0 Or posOfP = 1 Or posOfP = 2 Or inEndzone(p, teamOf(p)) = 10 Then
        shouldCatch = True
    End If
End Function

Function getReact(p)
    getReact = rea(teamOf(p), p Mod playersOnTeam)
End Function
Function checkIfScore(pl)
    t = teamOf(pl)
    'can only score on a pass into the endzone
    If (teamOf(whoThrewDisc) = t) Then
        'If we are Cornell
        If t = 0 Then
            'if pl is in appropriate endzone, then score!
            If facing(t) = RT Then
                If playerX(pl) > 285 Then
                    'MsgBox ("Score for " + teamName(t) + "!")
                    Announcer.Caption = teamName(t) + " scores!"
                    Announcer.Visible = True
                    announceTimer = 3
                    checkIfScore = True
                    score(teamOf(pl)) = score(t) + 1
                    updateScoreboard
                End If
            ElseIf facing(t) = LT Then
                If playerX(pl) < 60 Then
                    'MsgBox ("Score for " + teamName(t) + "!")
                    Announcer.Caption = teamName(t) + " scores!"
                    Announcer.Visible = True
                    announceTimer = 3
                    checkIfScore = True
                    score(teamOf(pl)) = score(t) + 1
                    updateScoreboard
                End If
            End If
        Else 'if we are Harvard
            If facing(t) = RT Then
                If playerX(pl) > 282 Then
                    'MsgBox ("Score for " + teamName(t) + "!")
                    Announcer.Caption = teamName(t) + " scores!"
                    Announcer.Visible = True
                    announceTimer = 3
                    checkIfScore = True
                    score(teamOf(pl)) = score(t) + 1
                    updateScoreboard
                End If
            ElseIf facing(t) = LT Then
                If playerX(pl) < 62 Then
                    'MsgBox ("Score for " + teamName(t) + "!")
                    Announcer.Caption = teamName(t) + " scores!"
                    Announcer.Visible = True
                    announceTimer = 3
                    checkIfScore = True
                    score(teamOf(pl)) = score(t) + 1
                    updateScoreboard
                End If
            End If
        End If
    End If
End Function
Sub setPlayerWithDisc(p)
    discMoving = False
    discTimer.Interval = 0
    stallTimer.Interval = 500
    stall = 0
    setDiscPos plDiscX(p), plDiscY(p)
    playerWithDisc = p
    duringPull = False
    teamOnO = teamOf(p)
    inPlay = 1
End Sub
Sub printJersey(p) 'CC
    j = trim(jersey(p))
    w = player(p).Width
    x = -1: y = -1
    c = 0
    t = teamOf(p)
    M = w / 2 - field.TextWidth(j) / 2 'middle of player
    Select Case teamName(t)
        Case "Cornell":
            If facing(0) = RT Then
                y = 5: mx = 5
            Else
                y = 5: mx = -7
            End If
        Case "Harvard":
            If facing(1) = RT Then
                y = 6: mx = 4
            Else
                y = 6: mx = -6
            End If
    End Select
    x = M + mx
    jerseyNum(p).ForeColor = QBColor(c)
    jerseyNum(p).Left = x + player(p).Left
    jerseyNum(p).Top = y + player(p).Top
    jerseyNum(p).Caption = j
    'bring image of jersey num to top layer of picture
    jerseyNum(p).ZOrder
End Sub
Function jersey(x) 'CC
    If teamOf(x) = 0 Then
        jersey = jer(teamOf(x), x)
    Else
        jersey = jer(teamOf(x), x - 7)
    End If
End Function

'linin' 'em up on the line....
Function startPosY(x) 'CC
    If x Mod playersOnTeam = 0 Then startPosY = 45
    If x Mod playersOnTeam = 1 Then startPosY = 60
    If x Mod playersOnTeam = 2 Then startPosY = 75
    If x Mod playersOnTeam = 3 Then startPosY = 90
    If x Mod playersOnTeam = 4 Then startPosY = 105
    If x Mod playersOnTeam = 5 Then startPosY = 120
    If x Mod playersOnTeam = 6 Then startPosY = 135
End Function
Sub setDiscPos(x, y) 'CC
    If Not (x = -1 Or y = -1) Then
        discPos(0) = x
        discPos(1) = y
    End If
    If discPos(0) <= 0 Then
        discPos(0) = 1
        discMoving = False
        outOfBounds = 1
        inPlay = 0
    End If
     If discPos(1) <= 40 Then
        discPos(1) = 41
        discMoving = False
        outOfBounds = 2
        inPlay = 0
    End If
    If discPos(0) >= fWidth - 5 Then
        discPos(0) = fWidth - 5
        discMoving = False
        outOfBounds = 3
        inPlay = 0
    End If
    If discPos(1) >= fHeight + 43 Then 'displace by out-of-bounds space
        discPos(1) = fHeight + 42
        discMoving = False
        outOfBounds = 4
        inPlay = 0
    End If
    'If notAllowed <> -1 Then outOfBounds = 0
    disc.Left = discPos(0) * 2.5
    disc.Top = discPos(1) * 2.5
    disc.ZOrder 'move disc to top
End Sub
Function updateScoreboard() 'CC
    tim$ = "   " + trim(gameTime) + ":00"
    Me.Caption = "   SCORE:  " + teamName(0) + " " + trim(score(0)) + " - " + teamName(1) + " " + trim(score(1)) + "                              GAME TIME:  " + tim$ + gam$
End Function
Function trim(x) 'CC
    trim = LTrim$(RTrim$(Str$(x)))
End Function
Private Sub gameAbout_Click()
    AboutBox.Visible = True
End Sub
Private Sub gameExit_Click()
    End
End Sub
Private Sub gameNew_Click()
    newGame
End Sub
Sub playerTimer_Timer() '
    'two cases, either the disc is in play or not in play
    Select Case inPlay
        Case 0: 'if disc is not in play
            Select Case goalScored 'there are two situations
                Case False: 'either (1) it is during a point and disc is on the ground,
                        'or has just been pulled and is about to hit the ground
                    'teamOnO picks up disc (p1 or 2 depending on position of disc)
                    If discTimer.Interval <> 0 Then 'if disc has just been pulled
                        'then move appropriate handler to the target pos of the disc
                        discX = discTarget(0)
                        discY = discTarget(1)
                        tPU = toPickUp(discX, discY)
                    Else 'if disc is already on the ground
                        discX = discPos(0)
                        discY = discPos(1)
                        tPU = toPickUp(discX, discY)
                    End If
                    'move player p to spot discX, discY
                    movePlayerToSpot tPU, discX, discY, True
                    'rest of teamOnO moves toward offensive positions
                    ' and rest of teamOnD moves toward defensive positions
                    ' (all relative to position of disc)
                    If goalScored = False Then
                        moveIntoPos tPU, discX, discY
                    End If
                Case True: 'or (2) it is between points and the team that just scored must pull it
                    discTimer.Enabled = True
                    pull
            End Select
        Case 1: 'if disc is in play
            Select Case playerWithDisc 'again, there are two situations
                Case -1: 'the disc is flying through the air
                    'person on each team closest to discTarget moves toward discTarget
                    pOnO = closestToSpot(teamOnO, discTarget(0), discTarget(1))
                    pOnD = closestToSpot(other(teamOnO), discTarget(0), discTarget(1))
                    movePlayerToSpot pOnO, discTarget(0), discTarget(1), True
                    movePlayerToSpot pOnD, discTarget(0), discTarget(1), True
                Case Else: 'someone has possession of the disc
                    'team continues to move into offensive positions until done
                    discX = discPos(0)
                    discY = discPos(1)
                    p = playerWithDisc
                    moveIntoPos p, discX, discY
                    
                    'find bestpass
                    toPassTo = bestPass
                    'make that pass
                    passDisc toPassTo
            End Select
        End Select
                    
End Sub
Sub passDisc(p)
    
    If playerWithDisc <> -1 And p <> -1 Then
        
        discMoving = True
        whoThrewDisc = playerWithDisc
        playerWithDisc = -1
        
        discStart(0) = discPos(0)
        discStart(1) = discPos(1)
        
        discTarget(0) = plDiscX(p)
        discTarget(1) = plDiscY(p)
          
        deltaX = discTarget(0) - discPos(0)
        deltaY = discTarget(1) - discPos(1)
        dist = (deltaX ^ 2 + deltaY ^ 2) ^ (1 / 2)
      
        For i = 0 To 1
            r = Int(Rnd * (20 - getAcc(whoThrewDisc)) + Rnd * 8)
            If dist > 35 Then
                r = r + (dist - 35) / 12
            End If
            If Int(Rnd * 2) = 1 Then r = -r
            r = accuracy
            discTarget(i) = discTarget(i) + r
        Next i
      
        discMove (False)
        If discMoving Then
            discTimer.Interval = 100
        End If
            
    End If
    
End Sub
Function bestPass()
    pwd = playerWithDisc
    t = teamOf(pwd)
    sta = t * (playersOnTeam)
    fin = sta + 6
    bestTot = 0
    'looping through players on O
    For x = sta To fin
        If x <> pwd Then
            'start collecting traits of this option and
            'give it a numerical value out of 100
            hands = getHan(x) * 3 / 4 'scale from 0 to 15
            accur = getAcc(x) * 3 / 4 'scale from 0 to 15
            posOfX = x Mod playersOnTeam
            If posOfX = 0 Or posOfX = 1 Or posOfX = 2 Then
                'if woman with disc has cup/other defenders in front of her,
                If intimidated(pwd) = True And closeToH(pwd) Then
                    'almost always dump to handlers
                    handler = 40
                Else
                    handler = 20 'scale from 0 to 20
                End If
            Else
                handler = 0
            End If
            If facing(t) = RT Then
                deltaX = playerX(x) - playerX(pwd)
            Else
                deltaX = playerX(pwd) - playerX(x)
            End If
            yardageGain = deltaX / 3.5 'scale from 0 to 30 (max distance is ~ 120)
            howOpen = playerNearby(x) 'scale from 0 to 20
            willScore = inEndzone(x, teamOf(x)) 'scale from 0 to 10
            randomness = Int(Rnd * 11) 'scale from 0 to 10
            total = hands + accur + handler + yardageGain + howOpen + willScore + randomness
            If total > bestTot Then
                bestTot = total
                bp = x
            End If
       End If
    Next x
    If stall = 9 Then
        Announcer.Caption = "Stall!  Turnover."
        Announcer.Visible = True
        announceTimer = 3
    End If
    If bestTot < 60 And stall < 10 Then
        bestPass = -1
    Else
        bestPass = bp
    End If

End Function
'returns true of there is a handler sufficiently close to p to dump
'here, sufficiently close is defined as w/in 40 game cells
Function closeToH(p)
    t = teamOf(p)
    sta = t * playersOnTeam 'handler 0
    fin = t * playersOnTeam + 2 'handler 2
    'distToH = 0
    For h = sta To fin
        dX = playerX(h) - playerX(p)
        dY = playerY(h) - playerY(p)
        dist = (dX ^ 2 + dY ^ 2) ^ (1 / 2)
        If dist < 40 Then closeToH = True
    Next h
        
End Function
'returns true if there are more than 2 players w/in 35 game cells IN FRONT of player p
Function intimidated(p)
    
    t = otherTeam(p)
    nearby = 40
    numNearby = 0 'number of players close to p and in front of p
    sta = t * playersOnTeam
    fin = sta + 6
    posOfP = p Mod playersOnTeam
    If posOfP = 0 Or posOfP = 1 Or posOfP = 2 Then
        intimidated = False
    Else
        For x = sta To fin
            If x <> p Then 'this should never be possible since x is from other team
                'first check to make sure the defense is in front of p
                If (playerX(x) < playerX(p) And facing(teamOf(p)) = LT) Or (playerX(x) > playerX(p) And facing(teamOf(p)) = RT) Then
                    dX = playerX(x) - playerX(p)
                    dY = playerY(x) - playerY(p)
                    dist = (dX ^ 2 + dY ^ 2) ^ (1 / 2)
                    If dist < nearby Then
                        numNearby = numNearby + 1
                    End If
                End If
            End If
        Next x
        If numNearby >= 2 Then
            intimidated = True
        Else
            intimidated = False
        End If
    End If
End Function
'returns 10 if p is in the endzone team t is trying to score in, 0 otherwise
Function inEndzone(p, t)
    inEndzone = 0
    If facing(t) = RT Then
        If playerX(p) > 280 Then inEndzone = 10
    Else
        If playerX(p) < 68 Then inEndzone = 10
    End If
End Function

'inputs index of player with disc, and the x,y position of the disc
'used by bestPass
'returns how close the nearest player from other team is
Function playerNearby(p)
    t = otherTeam(p)
    closest = 21
    sta = t * playersOnTeam
    fin = sta + 6
    For x = sta To fin
        If x <> p Then
            dX = playerX(x) - playerX(p)
            dY = playerY(x) - playerY(p)
            dist = (dX ^ 2 + dY ^ 2) ^ (1 / 2)
            If dist > 20 Then
                pN = 20
            Else
                pN = dist
            End If
        End If
        If pN < closest Then closest = pN
    Next x
    playerNearby = closest
End Function
Sub moveIntoPos(pWithDisc, dX, dY)
    
    For i = 0 To players
        If i <> pWithDisc Then
            If teamOf(i) = teamOnO Then
                'try to move player to ideal spot in zone O
                movePlayerToSpot i, oPosX(dX, dY, i), oPosY(dX, dY, i), False
                
            Else
                'try to move player to ideal spot in zone D
                movePlayerToSpot i, dPosX(dX, dY, i), dPosY(dX, dY, i), False
            End If
        End If
    Next i
    
End Sub
'returns ideal x coordinate of oPos for player p if we had no out of bounds
'note: this function is only called with a player p who does NOT have the disc
Function oPosX(dX, dY, p)
    Select Case p
        Case 0, 7: 'dumps
            oPosX = dX - 15 + facing(teamOf(p)) * (30 + 15)
        Case 1, 2, 8, 9: 'handlers (assuming p does have the disc!)
            oPosX = dX - 15 + facing(teamOf(p)) * (30 + 15)
        Case 3, 10: 'poppers
            oPosX = dX + 60 - facing(teamOf(p)) * (120 + 15)
        Case 4, 5, 11, 12: 'wings
            oPosX = dX + 80 - facing(teamOf(p)) * (160 + 15)
        Case 6, 13: 'deeps
            oPosX = dX + 105 - facing(teamOf(p)) * (210 + 15)
    End Select
End Function
'returns ideal y coordinate of oPos for player p if we had no out of bounds
'note: this function is only called with a player p who does NOT have the disc
Function oPosY(dX, dY, p)
    Select Case p
        Case 0, 3, 6, 7, 10, 13:
            'dumps, poppers, and deeps (positions that line up down the middle)
            If dY >= 100 Then
                oPosY = dY - 35
            Else
                oPosY = dY + 35
            End If
        Case 1, 4, 8, 11:
            'south side handlers or wings
            If dY >= 100 Then
                oPosY = dY + 10
            Else
                oPosY = dY + 70
            End If
        Case 2, 5, 9, 12:
            'north side handlers or wings
            If dY >= 100 Then
                oPosY = dY - 70
            Else
                oPosY = dY - 15
            End If
    End Select
End Function
'returns ideal x coordinate of dPos for player p if we had no out of bounds
Function dPosX(dX, dY, p)
    Select Case p
        Case 0, 7: 'guarding deep (staying behind 'em!)
            dPosX = dX - 135 - 15 + facing(teamOf(p)) * 270 + 15
        Case 1, 2, 8, 9: 'guarding wing (just outside and slightly fronting)
            dPosX = dX - 115 - 15 + facing(teamOf(p)) * 230 + 15
        Case 3, 10: 'rovers (guarding poppers, just behind)
            dPosX = dX - 90 - 15 + facing(teamOf(p)) * 180 + 15
        'and now for the cup
        Case 4, 11: 'point on the south side of cup
            If dY >= 100 Then
                'we are on mark
                dPosX = dX - 20 + facing(teamOf(p)) * 25
            Else
                'we are not on mark
                dPosX = dX - 25 + facing(teamOf(p)) * 35
            End If
        Case 6, 13: 'middle-middle of the cup
            dPosX = dX - 35 + facing(teamOf(p)) * 55
        Case 5, 12: 'point on north side of cup
            If dY >= 100 Then
                'we are not on mark
                dPosX = dX - 30 + facing(teamOf(p)) * 50
            Else
                'we are on mark
                dPosX = dX - 20 + facing(teamOf(p)) * 25
            End If
    End Select
End Function
'returns ideal y coordinate of dPos for player p if we had no out of bounds
Function dPosY(dX, dY, p)
    Select Case p
        Case 0, 3, 7, 10: 'guarding deep (staying behind 'em!) and rovers (guarding poppers, just behind)
            If dY >= 100 Then
                dPosY = dY - 35
            Else
                dPosY = dY + 35
            End If
            
        Case 1, 8: 'guarding wing on south side (just outside and slightly fronting)
            If dY >= 100 Then
                dPosY = dY + 15
            Else
                dPosY = dY + 85
            End If
        Case 2, 9: 'guarding wing on north side (just outside and slightly fronting)
            If dY >= 100 Then
                dPosY = dY - 85
            Else
                dPosY = dY - 15
            End If
        'and now for the cup
        Case 4, 11: 'point on the south side of cup
            If dY >= 100 Then
                'we are on mark
                dPosY = dY + 5
            Else
                'we are not on mark
                dPosY = dY - 20
            End If
        Case 6, 13: 'middle-middle of the cup
            'always be toward middle of field
            If dY >= 100 Then
                dPosY = dY
            Else
                dPosY = dY
            End If
        Case 5, 12: 'point on north side of cup
            If dY >= 100 Then
                'we are not on mark
                dPosY = dY - 15
            Else
                'we are on mark
                dPosY = dY + 5
            End If
    End Select
End Function 'inputs index of player to be moved, and x,y coordinates of destination
Private Sub movePlayerToSpot(p, dX, dY, goFor)
    
    pdX = plDiscX(p) 'position of disc in player p's possession
    pdY = plDiscY(p)
    plX = playerX(p) 'position of player p
    plY = playerY(p)

    deltaX = dX - pdX: deltaY = dY - pdY
    
    s = speed(p)
    dist = (deltaX ^ 2 + deltaY ^ 2) ^ (1 / 2)
    If dist < s Then s = dist
    'boolean values:
    dXClose = near(deltaX, 0, s) 'is the desired position w/in s of current position
    dYClose = near(deltaY, 0, s)
    dsClose = near(dist, s, 1) Or (dXClose And dYClose)
    
    If Not dsClose And Not dYClose Then
        If (deltaY <> 0 And deltaX <> 0) Then
            ratio = deltaX / deltaY
            If (Not near(ratio, 1, 0.2)) And (Not near(ratio, -1, 0.2)) Then
                sqrt = s ^ 2 / Abs(ratio ^ 2 - 1)
            Else
                sqrt = (s ^ 2) / 2
            End If
            moveY = sqrt ^ (1 / 2)
            If deltaY < 0 Then moveY = -moveY
            moveX = ratio * moveY
        Else
            If deltaY = 0 Then
                moveX = s: moveY = 0
                If deltaX < 0 Then moveX = -moveX
            End If
            If deltaX = 0 Then
                moveX = 0: moveY = s
                If deltaY < 0 Then moveY = -s
            End If
        End If
        newX = plX + moveX
        newY = plY + moveY
    Else
        If dsClose Then
            newX = dX
            newY = dY
            newY = newY - 5
        ElseIf dXClose Then
                moveY = s
                If deltaY < 0 Then moveY = -s
                newY = plY + moveY
                newX = dX
        ElseIf dYClose Then
                moveX = s
                If deltaX < 0 Then moveX = -moveX
                newX = plX + moveX
                newY = dY
                newY = newY - 5
        End If
    End If
    
    'take care of O.B. situations
    If newX < 0 Then newX = 0
    If newX > fWidth - 16 Then newX = fWidth - 16
    If newY < 40 Then newY = 40
    If newY > fHeight + 40 - 13 Then newY = fHeight + 40 - 13
    setPlayerPos p, newX, newY, goFor
    'checkForOpp -1
End Sub
'takes in parameter of disc location (or disc target location) and determines which
'handler should pick it up.
Function toPickUp(x, y)
    'if disc is below midfield (40 + 60)
    If y < 100 Then
        toPickUp = 2 + teamOnO * 7 'handler 1 picks up
    Else
        toPickUp = 1 + teamOnO * 7 'handler 2 picks up
    End If
End Function
Sub gameTimer_Timer() 'CC
    'update announcer label
    If announceTimer > 0 Then
        announceTimer = announceTimer - 1
    Else
        Announcer.Visible = False
    End If
    If outOfBounds = 0 Then
        If gameTimer < 120 Then gameTime = gameTime + 1
        updateScoreboard
        If gameTime >= 120 Then
            gameTimer.Enabled = False
            discTimer.Interval = 0
            playerTimer.Interval = 0
            Announcer.Visible = False
            msg = MsgBox("Start New Game?", 36, "GAME OVER")
            
            If msg = vbYes Then
                newGame
            Else
                gameTimer.Enabled = False
            End If
        End If
    End If
End Sub
Private Sub discTimer_Timer() 'CC
    If duringPull Then
        'move disc and don't check if anyone can catch it
        discMove (True)
    Else
        'move disc and check if anyone can catch it
        discMove (False)
    End If
End Sub
Sub pull() 'CC
    duringPull = True
    whoThrewDisc = playerWithDisc
    playerWithDisc = -1
    discStart(0) = discPos(0)
    discStart(1) = discPos(1)
    'set target for pull depending on which team is pulling
    'toward back of the endzone
    discTarget(0) = 330 - 300 * facing(teamOnO)
    'have the time we aim for north corner, other half, south corner.
    discTarget(1) = 130 - Int(Rnd * 2) * 60
    'calculate distance from disc to target
    deltaX = discTarget(0) - discPos(0)
    deltaY = discTarget(1) - discPos(1)
    dist = (deltaX ^ 2 + deltaY ^ 2) ^ (1 / 2)
  
    For i = 0 To 1
        r = Int(Rnd * (20 - getAcc(whoThrewDisc)) + Rnd * 12)
        If dist > 35 Then
            r = r + (dist - 35) / 12
        End If
        If Int(Rnd * 2) = 1 Then r = -r
        'r=accuracy
        discTarget(i) = discTarget(i) + r
    Next i
    
    'adjust for out-of-bounds cases
    'If discTarget(0) > 355 Then discTarget(0) = 355
    'If discTarget(1) > 120 Then discTarget(1) = 120
    
    discMove (True) 'call discMove(True)- True indicates we are in a pull
    teamOnO = other(teamOnO)
    discTimer.Interval = 100
    goalScored = False
       
End Sub
Function other(team)
    If team = 0 Then other = 1
    If team = 1 Then other = 0
End Function
'if pull = True, then we will not call canGetDisc
Sub discMove(pull) 'some code adapted from Shepherd Soccer Simulator
    
    discMoving = True
    playerWithDisc = -1
    If (Not near(discTarget(0), discPos(0), 5) Or Not near(discTarget(1), discPos(1), 5)) Then
        deltaX = discTarget(0) - discPos(0)
        deltaY = discTarget(1) - discPos(1)
        power = dis(teamOf(whoThrewDisc), whoThrewDisc Mod playersOnTeam)
        dist = (deltaX ^ 2 + deltaY ^ 2) ^ (1 / 2)
        If dist < power Then power = dist
        
        dXClose = near(deltaX, 0, 1)
        dYClose = near(deltaY, 0, 1)
        dpClose = near(dist, power, 1)
        
        If Not dpClose And Not dYClose Then
            If (deltaY <> 0 And deltaX <> 0) Then
                ratio = deltaX / deltaY
                If (Not near(ratio, 1, 0.2)) And (Not near(ratio, -1, 0.2)) Then
                    sqrt = power ^ 2 / Abs(ratio ^ 2 - 1)
                Else
                    sqrt = (power ^ 2) / 2
                End If
                moveY = sqrt ^ (1 / 2)
                If deltaY < 0 Then moveY = -moveY
                moveX = ratio * moveY
            Else
                If deltaY = 0 Then
                    moveX = power: moveY = 0
                    If deltaX < 0 Then moveX = -moveX
                End If
                If deltaX = 0 Then
                    moveX = 0: moveY = power
                    If deltaY < 0 Then moveY = -power
                End If
            End If
            discPos(0) = discPos(0) + moveX
            discPos(1) = discPos(1) + moveY
        Else
            If dXClose Then
                moveY = power
                If deltaY < 0 Then moveY = -power
                discPos(1) = discPos(1) + moveY
            ElseIf dYClose Then
                moveX = power
                If deltaX < 0 Then moveX = -moveX
                discPos(0) = discPos(0) + moveX
            End If
            If dpClose Or dXClose Then
                discPos(0) = discTarget(0)
            End If
            If dpClose Or dYClose Then
                discPos(1) = discTarget(1)
            End If
        End If
        setDiscPos -1, -1 'moves the disc to the new position
    Else
        discMoving = False
        discTimer.Interval = 0
        discPos(0) = discTarget(0)
        discPos(1) = discTarget(1)
        setDiscPos -1, -1
    End If
    
    If (outOfBounds = 0) Then
        If (pull = False) Then
            canGetDisc (-1)
        End If
    Else 'if out of bounds
        'If it was pulled out of bounds,
        If duringPull = True Then
            Announcer.Caption = "Pulled out of Bounds!"
            Announcer.Visible = True
            announceTimer = 3
            'move disc to front of endzone and proceed
            discPos(0) = 75 + facing(teamOnO) * 210
            If outOfBounds = 1 Then 'if out on west side of field
                discPos(1) = discTarget(1)
                setDiscPos -1, -1
                'playerWithDisc = -1
            ElseIf outOfBounds = 2 Then 'if out on north side of field
                discPos(1) = 40
                setDiscPos -1, -1
            ElseIf outOfBounds = 3 Then 'out on east side
                discPos(1) = discTarget(1)
                setDiscPos -1, -1
            Else
                'it must be out of bounds on south side of field
                discPos(1) = 157
                setDiscPos -1, -1
            End If
            outOfBounds = 0 'disc is back in bounds
            goalScored = False
            inPlay = 0
            discTimer.Interval = 0
        Else 'If during a point
            Announcer.Caption = "Out of Bounds!  Turnover. " + teamName(other(teamOnO)) + " disc"
            Announcer.Visible = True
            announceTimer = 3
            'turnover!!!
            teamOnO = other(teamOnO)
            outOfBounds = 0 'putDiscInBounds
            discMoving = False
            inPlay = 0
            discTimer.Interval = 0
        End If
    End If
    
End Sub
Function speed(x)
    speed = spe(teamOf(x), x Mod playersOnTeam) * 3 / 4
End Function
Function closestToSpot(t, spotX, spotY)  'called by playertimer
    sta = t * (playersOnTeam)
    closest = -1
    Min = 100000000
    For x = sta To sta + totPlayers
        deltaX = plDiscX(x) - spotX
        deltaY = plDiscY(x) - spotY
        dist = (deltaX ^ 2 + deltaY ^ 2)
        If dist < Min Then
            closest = x
            Min = dist
        End If
    Next x
    closestToSpot = closest
End Function
Function near(x, y, z) 'CC
    If Abs(x - y) <= Abs(z) Then
        near = True
    Else
        near = False
    End If
End Function
Function plDiscX(Index) 'CC
    If facing(teamOf(Index)) = RT Then
        plDiscX = playerX(Index) + 12
    Else
        plDiscX = playerX(Index)
    End If
End Function
Function plDiscY(Index) 'CC
    plDiscY = playerY(Index) + 5
End Function
Private Sub stallTimer_Timer()
    stall = stall + 1
End Sub
